﻿unit Niksms;

interface
uses
System.DateUtils, Model,Enums.TSendMethod,Enums.TSmsStatus,Enums.TSmsReturn, IdHttp,Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient;
type
  // Define a parent class, base on TObject by default
  NikSmsClass = class
    private
      _username : string;
      _password : string ;
      _method : TSendMethod;

    public
      username   : string;
      password   : string;

type
    TGetReceiveSmsModelArray = array of GetReceiveSmsModel;
    TEnumsTSmsStatusArray =  array of TSmsStatus;

    Constructor Create(username : string; password:string); overload;
    Constructor Create(username : string; password:string; method: TSendMethod); overload;
    function ExecuteRequest(path:string;postData: string; method : TSendMethod):string;

//  function GroupSms(senderNumber:string; numbers :string; sendOn: TDateTime;
//  sendType: integer; yourMessageIds:string; message: string): ReturnSmsResult;
    function GroupSms(senderNumber:string; numbers :string; sendOn: TDateTime;
    sendType: integer; yourMessageIds:string; message: string): string;

//  function PtpSms(senderNumber:string; numbers :string; sendOn: TDateTime;
//  sendType: integer; yourMessageIds:string; message: string):ReturnSmsResult;
    function PtpSms(senderNumber:string; numbers :string; sendOn: TDateTime;
    sendType: integer; yourMessageIds:string; message: string):string;

    function GetCredit():Integer;
    function GetDiscountCredit():Integer;
    function GetPanelExpireDate():TDateTime;

//  function GetReceiveSms(startDate : TDateTime; endDate : TDateTime):TGetReceiveSmsModelArray;
    function GetReceiveSms(startDate : TDateTime; endDate : TDateTime):string;

    function ResetReceiveSmsVisitedStatus(startDate : TDateTime; endDate : TDateTime):Boolean;

//  function GetSmsDelivery(nikIds : string):TEnumsTSmsStatusArray;
    function GetSmsDelivery(nikIds : string):string;
    function GetServertime():TDateTime;

  end;


implementation

  constructor NikSmsClass.Create(username : string; password:string);
  begin
    _username := username;
    _password := password;
    _method := TSendMethod.Get;
  end;

  constructor NikSmsClass.Create(username : string; password:string;method: TSendMethod);
  begin
    _username := username;
    _password := password;
    _method := method;
  end;

  function NikSmsClass.GetCredit:Integer;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/getCredit';
            postData := 'username='+ _username + '&password=' + _password;

            response := (ExecuteRequest(path,postData,_method));
            GetCredit := response.ToInteger();
  end;

  function NikSmsClass.GroupSms(senderNumber:string; numbers :string; sendOn: TDateTime;
    sendType: integer; yourMessageIds:string; message: string):string;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GroupSms';
            postData := 'username='+ _username + '&password=' + _password +
            '&senderNumber=' + senderNumber + '&numbers=' + numbers +
            '&sendOn=' + DateToISO8601(sendOn) + '&sendType=' + sendType.ToString() +
            '&yourMessageIds=' + yourMessageIds + '&message=' + message ;

            response := (ExecuteRequest(path,postData,_method));
            GroupSms := response;
  end;

   function NikSmsClass.PtpSms(senderNumber:string; numbers :string; sendOn: TDateTime;
    sendType: integer; yourMessageIds:string; message: string):string;
 var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/PtpSms';
            postData := 'username='+ _username + '&password=' + _password +
            '&senderNumber=' + senderNumber + '&numbers=' + numbers +
            '&sendOn=' + DateToISO8601(sendOn) + '&sendType=' + sendType.ToString() +
            '&yourMessageIds=' + yourMessageIds + '&message=' + message;

            response := (ExecuteRequest(path,postData,_method));
            PtpSms := response;
  end;

   function NikSmsClass.GetPanelExpireDate:TDateTime;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GetPanelExpireDate';
            postData := 'username='+ _username + '&password=' + _password;

            response := (ExecuteRequest(path,postData,_method));
            GetPanelExpireDate := StrToDateTime(response) ;
  end;

  function NikSmsClass.GetDiscountCredit:Integer;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GetDiscountCredit';
            postData := 'username='+ _username + '&password=' + _password;

            response := (ExecuteRequest(path,postData,_method));
            GetDiscountCredit := response.ToInteger();
  end;

  function NikSmsClass.ResetReceiveSmsVisitedStatus
  (startDate : TDateTime; endDate : TDateTime):Boolean;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/resetReceiveSmsVisitedStatus';
            postData := 'username='+ _username + '&password=' + _password +
            '&startDate=' + DateToISO8601(startDate) + '&endDate=' + DateToISO8601(endDate);
            response := (ExecuteRequest(path,postData,_method));
if response = 'True' then
                          ResetReceiveSmsVisitedStatus:= True;
if response = 'False' then
           ResetReceiveSmsVisitedStatus:= False;
  end;

  function NikSmsClass.GetServerTime:TDateTime;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GetServerTime';
            postData := 'username='+ _username + '&password=' + _password;

            response := (ExecuteRequest(path,postData,_method));
            GetServerTime := Now;
  end;

  function NikSmsClass.GetReceiveSms(startDate : TDateTime; endDate : TDateTime):string;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GetReceiveSms';
            postData := 'username='+ _username + '&password=' + _password +
            '&startDate=' + DateToISO8601(startDate) + '&endDate=' + DateToISO8601(endDate);

            response := (ExecuteRequest(path,postData,_method));
            GetReceiveSms := response;
  end;

  function NikSmsClass.GetSmsDelivery(nikIds: string):string;
  var
  path : string;
  postData : string;
  response : string;
        begin
            path := 'http://www.niksms.com/fa/publicapi/GetSmsDelivery';
            postData := 'username='+ _username + '&password=' + _password +
            '&nikIds=' + nikIds;
            response := (ExecuteRequest(path,postData,_method));
            GetSmsDelivery := response;
  end;

  function NikSmsClass.ExecuteRequest(path : string; postData:string;method: TSendMethod):string;
    var
    responseStream : TMemoryStream;
     http: TIdHTTP;
      parameters: TStringStream;
  begin
    _username := _username;
    _password := _password;
    _method := method;

     try
      try
        responseStream := TMemoryStream.Create;
        http := TIdHTTP.Create(nil);
        //http.OnWork:= HttpWork;
        http.Request.ContentType := 'application/x-www-form-urlencoded';
        http.Request.ContentEncoding := 'utf-8';
        http.Response.CharSet := 'utf-8';
        //http.HTTPOptions := [hoForceEncodeParams];
        http.Request.CharSet := 'utf-8';
        if method = TSendMethod.Get then
        begin
        http.Get(path + '?' + postData, responseStream);
        end;
        if method = TSendMethod.Post then
        begin
        parameters := TStringStream.Create(postData, TEncoding.UTF8);
        http.Post(path, parameters, responseStream);
        end;


        SetString(result, PAnsiChar(responseStream.Memory), responseStream.Size);
      except
//        on E: Exception do
//            Global.LogError(E, 'ProcessHttpRequest');
      end;
    finally
      try
        http.Disconnect;
      except
      end;
    end;
  end;

end.
